{$A+,B-,D+,E-,F+,G+,I-,L+,N+,O+,P-,Q-,R-,S-,T-,V+,X+}
{$M 65520,0,655360}
unit liczby;
{/*                                         */}
{/* PRZYKLADOWY UNIT ARYTMETYCZNY           */}
{/* JEZYK - PASCAL                          */}
{/* IMPLEMENTACJA - TURBO                   */}
{/* AUTOR - FILIP PIEKNIEWSKI               */}
{/*                                         */}
{/* philip@mat.uni.torun.pl                 */}
{/*                                         */}
interface

type liczba = array[0..31] of byte;

var  zero : Liczba;  {zero w istocie bedzie uzywana jako stala }

{/*                                         */}
procedure init( var L   : Liczba);
function  CMP ( var A,B : Liczba)   : Byte;
procedure IncL( var L   : Liczba; c : byte);
procedure mulL( var L   : Liczba; c : Byte);
procedure divL( var L   : Liczba; c : Byte; var M : Byte);

procedure Liczba2Str(L : Liczba; Var S : String);
procedure Str2Liczba(S : String; Var L : Liczba);

procedure ADD(  var A,B : Liczba);
procedure Sub(  var A,B : Liczba);
procedure MUL(  var A,B : Liczba);
procedure DIV_L(var A,B : Liczba);
procedure MOD_L(var A,B : Liczba);




implementation


{ Wyzerowanie zmiennej  }
procedure init( var L : Liczba);
var i : Byte;
begin
  for i:=0 to 31 do L[i]:=0;
end;

{ Porownanie dwoch zmiennych }
function CMP(var a,b : Liczba) : Byte;
Var I : Byte;
Begin
  I:=31;
  While (A[i]=B[i])and(I>0) do dec(i);
  if (i=0)and(A[i]=B[i]) then CMP:=0 else
  Begin
    if A[i]>B[i] then CMP:=1 else CMP:=2;
  end;
End;

{ Powiekszenie liczby o zakres bajtu }
procedure IncL(var l : Liczba; c : byte);
var W : Word;
    i : Byte;
Begin
  W:=c;
  i:=0;
  Repeat
    W:=W+L[i];
    L[i]:=W and 255;
    W:=W shr 8;
    i:=i+1;
  Until W=0;
end;

{ Pomnozenie liczby przez bajt  }
procedure mulL(var l : Liczba; c : Byte);
var W : Word;
    i : Byte;
Begin
  W:=0;
  for i:=0 to 31 do
    Begin
      W:=W+L[i]*c;
      L[i]:=W and 255;
      W:=W shr 8;
    end;
end;

{ Dzielenie liczby przez bajt oraz modulo }
procedure divL(var L : Liczba;c : Byte; var M : Byte);
var W : Word;
    i : Byte;
begin
  W:=0;
  for i:=31 downto 0 do
  begin
    W:=(W shl 8) + L[i];
    L[i]:=W div c;
    W:=W mod c;
  end;
  M:=W and 255;
end;

{ Konwersja liczby na system dziesietny zapisany w string }
Procedure Liczba2Str(L : Liczba;Var S : String);
Var i,j : Integer;
      m : Byte;
      c : Char;
Begin
  S:='';
  J:=31;
  While (j>=0)and(L[j]=0) do Dec(j);
  While j>=0 do
  Begin
    DIVL(L,10,m);
    S:=S+Char(m+48);
    If L[j]=0 Then Dec(j);
  End;
  If s='' Then S:='0' Else
  Begin
    For i:=1 to (Length(s) div 2) do
    Begin
      c:=S[i];
      S[i]:=S[(Length(s)-i+1)];
      S[(Length(s)-i+1)]:=C;
    End;
  End;
End;

{ Konwersja z zystemu dziesietnego w string na liczbe }
Procedure Str2Liczba(S : String; Var L : Liczba);
Var i : Integer;
Begin
  Init(L);
  For i:=1 to Length(s)-1 do
  Begin
    INCL(L,(Byte(S[i])-48));
    MULL(l,10);
  End;
  INCL(L,(Byte(S[Length(s)])-48));
End;

{ Dodawanie do liczby a liczby b }
procedure ADD(var a,b : Liczba);
var W : Word;
    I : Byte;
Begin
  W:=0;
  For i:=0 to 31 do
    Begin
      W:=W+A[i]+B[i];
      A[i]:=W and 255;
      W:=W shr 8;
    End;
End;

{ Odejmowanie liczby b od liczby a }
Procedure Sub(var a,b : Liczba);
Var i : Word;
    c,r : Word;
Begin
  r:=0; { Uwaga - warto sprawdzic zakres }
  For I:=0 to 32 do
    Begin
      C:=1;
      C:=C shl 8;
      C:=C+A[i]-B[i]-r;
      A[i]:=C and 255;
      C:=C shr 8;
      if C=0 Then R:=1 Else R:=0;
    End;
End;

{ Przesuwanie w lewo o zadana ilosc bitow }
Procedure SHLL(Var V : Liczba; k : Integer);
Var i,j : Word;
    c : Word;
Begin
  i:=k shr 3;
  c:=0;
  If i>0 Then
  Begin
    For j:=31 downto i do V[j]:=V[j-i];
    For j:=i-1 downto 0 do V[j]:=0;
  End;
  i:=k and 7;
  If i>0 Then
  Begin
    For j:=31 downto 1 do
    Begin
      c:=V[j];
      c:=c shl 8;
      C:=c + V[j-1];
      c:=c shr (8-i);
      V[j]:=C and 255;
    End;
    c:=V[0];
    c:=C shl i;
    V[0]:=C and 255;
  End;
End;

{ Przesuwanie w prawo o zadana ilosc bitow }
Procedure SHRL(Var V : Liczba; k : Integer);
Var i,j : Word;
      c : Word;
Begin
  i:=k shr 3;
  c:=0;
  If i>0 Then
  Begin
    For j:=0 to (31-i) do V[j]:=V[j+i];
    For j:=(31-i) to 31 do V[j]:=0;
  End;
  i:=k and 7;
  If i>0 Then
  Begin
    For j:=0 to 31-1 do
    Begin
      c:=V[j+1];
      c:=c shl 8;
      c:=c + V[j];
      c:=c shr i;
      V[j]:=C and 255;
    End;
    c:=V[31];
    C:=c shr i;
    V[31]:=C and 255;
  End;
End;

{ Mnozenie liczby a przez liczbe b }
Procedure MUL(var a,b : Liczba);
Var i,j : Word;
    C,W : Liczba;
Begin
  Init(w);
  Init(c);
  i:=31;
  While (b[i]=0)and(i>0) do Dec(i);
  For j:=i downto 0 do
  Begin
    SHLL(W,8);
    C:=A;
    MULL(C,B[j]);
    ADD(W,C);
  End;
  A:=W;
End;

{ Stan i-tego bitu liczby V }
Function Bin(V : Liczba; i : Word) : Byte;
Var j : Integer;
    k : integer;
    z : Integer;
Begin
  j:=i shr 3;
  k:=i and 7;
  z:=1;
  z:=z shl (k);
  if (V[j] And z)=z Then Bin:=1 Else Bin:=0;
End;

{ Ustawienie i-tego bitu liczby V}
Procedure SetB(Var V : Liczba; i : Word);
Var j : Integer;
    k : Integer;
    z : Integer;
Begin
  j:=i shr 3;
  k:=i and 7;
  z:=1;
  z:=z shl (k);
  V[j]:=V[j] or Z;
End;

{ Dlugosc rozwiniecia binarnego liczby }
Function BLen(V : Liczba) : Integer;
Var k : Integer;
    i : Integer;
Begin
 k:=(31+1)*8;
 For i:=k-1 downto 0 do if BIN(V,i)=1 Then Break;
 if (i=0)and(Bin(V,0)=0) Then BLen:=-1 Else Blen:=i;
End;

{ Dzielenie liczby a przez b }
Procedure DIV_L(var a,b : Liczba);
Var i,k,l : Integer;
   P1,P,d,W : Liczba;

Begin
  Init(p1);
  Init(d);
  Init(p);
  Init(W);
  i:=BLen(a)-Blen(b);
  if (i>0)and(Blen(b)<>-1) Then
  Begin
    d:=b;
    SHLL(d,i);
    For k:=i downto 0 do
    Begin
     ADD(p1,d);
     if CMP(a,p1)<>2 Then Begin SETB(W,k); Add(p,d); End;
     p1:=p;
     SHRL(d,1);
    End;
  End;
  a:=W;
End;

{ Reszta z dzieleia liczby a przez b }
Procedure MOD_L(var a,b : Liczba);
Var i,k : Integer;
   P1,P,d,M : Liczba;

Begin
  Init(p1);
  Init(p);
  i:=BLen(a)-Blen(b);
  if (i>0)and(Blen(b)<>-1) Then
  Begin
    d:=b;
    SHLL(d,i);
    For k:=i downto 0 do
    Begin
     ADD(p1,d);
     if CMP(a,p1)<>2 Then Begin; Add(p,d); End;
     p1:=p;
     SHRL(d,1);
    End;
    m:=a;
    SUB(m,p);
    a:=m;
  End Else Begin if CMP(a,b)=2 Then M:=a Else
  begin m:=a; SUB(m,b); a:=m; end; End;
End;


begin
 init(zero); { Wyzerowanie zera }
end.
